JAXBContextFactory (Java SE 10 & JDK 10 )
Keywords: javax.xml.bind.JAXBContextFactory interface

Module java.xml.bind
Package javax.xml.bind

## Interface JAXBContextFactory

-     public interface JAXBContextFactory

  Factory that creates new `JAXBContext` instances. JAXBContextFactory can be located using `ServiceLoader.load(Class)`

  Since:
    9, JAXB 2.3

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `JAXBContext` | `createContext​(Class<?>[] classesToBeBound, Map<String,?> properties)` | Create a new instance of a `JAXBContext` class.
    `JAXBContext` | `createContext​(String contextPath, ClassLoader classLoader, Map<String,?> properties)` | Create a new instance of a `JAXBContext` class.

- - ### Method Detail

    - #### createContext

          JAXBContext createContext​(Class<?>[] classesToBeBound,
                                    Map<String,?> properties)
                             throws JAXBException

      Create a new instance of a `JAXBContext` class.

      For semantics see `JAXBContext.newInstance(Class[], java.util.Map)`

      Parameters:
        `classesToBeBound` - List of java classes to be recognized by the new `JAXBContext`. Classes in `classesToBeBound` that are in named modules must be in a package that is open to at least the `java.xml.bind` module. Can be empty, in which case a `JAXBContext` that only knows about spec-defined classes will be returned.
        `properties` - provider-specific properties. Can be null, which means the same thing as passing in an empty map.
      Returns:
        A new instance of a `JAXBContext`.
      Throws:
        `JAXBException` - if an error was encountered while creating the `JAXBContext`, such as (but not limited to):
        1. No JAXB implementation was discovered
        2. Classes use JAXB annotations incorrectly
        3. Classes have colliding annotations (i.e., two classes with the same type name)
        4. The JAXB implementation was unable to locate provider-specific out-of-band information (such as additional files generated at the development time.)
        5. `classesToBeBound` are not open to `java.xml.bind` module
        `IllegalArgumentException` - if the parameter contains `null` (i.e., `newInstance(null,someMap);`)
      Since:
        9, JAXB 2.3

    - #### createContext

          JAXBContext createContext​(String contextPath,
                                    ClassLoader classLoader,
                                    Map<String,?> properties)
                             throws JAXBException

      Create a new instance of a `JAXBContext` class.

      For semantics see `JAXBContext.newInstance(String, ClassLoader, java.util.Map)`

      The interpretation of properties is up to implementations. Implementations must throw `JAXBException` if it finds properties that it doesn't understand.

      Parameters:
        `contextPath` - List of java package names that contain schema derived classes. Classes in `classesToBeBound` that are in named modules must be in a package that is open to at least the `java.xml.bind` module.
        `classLoader` - This class loader will be used to locate the implementation classes.
        `properties` - provider-specific properties. Can be null, which means the same thing as passing in an empty map.
      Returns:
        a new instance of a `JAXBContext`
      Throws:
        `JAXBException` - if an error was encountered while creating the `JAXBContext` such as
        1. failure to locate either ObjectFactory.class or jaxb.index in the packages
        2. an ambiguity among global elements contained in the contextPath
        3. failure to locate a value for the context factory provider property
        4. mixing schema derived packages from different providers on the same contextPath
        5. packages are not open to `java.xml.bind` module
      Since:
        9, JAXB 2.3